// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Bcm.idl.

package com.raritan.json_rpc.pdumodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Bcm_Proxy extends ObjectProxy implements com.raritan.idl.pdumodel.Bcm {

  public Bcm_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Bcm_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.pdumodel.Bcm.typeInfo);
  }

  public static Bcm_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Bcm_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetChannelCountResult getChannelCount() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getChannelCount", params);
    GetChannelCountResult ret = new GetChannelCountResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getChannelCount(final AsyncRpcResponse<GetChannelCountResult> rsp) {
    return getChannelCount(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getChannelCount(final AsyncRpcResponse<GetChannelCountResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getChannelCount", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetChannelCountResult ret = new GetChannelCountResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetChannelConfigsResult getChannelConfigs() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getChannelConfigs", params);
    GetChannelConfigsResult ret = new GetChannelConfigsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.pdumodel.Bcm.ChannelConfig>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.pdumodel.Bcm.ChannelConfig_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getChannelConfigs(final AsyncRpcResponse<GetChannelConfigsResult> rsp) {
    return getChannelConfigs(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getChannelConfigs(final AsyncRpcResponse<GetChannelConfigsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getChannelConfigs", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetChannelConfigsResult ret = new GetChannelConfigsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.pdumodel.Bcm.ChannelConfig>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.pdumodel.Bcm.ChannelConfig_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetChannelConfigResult setChannelConfig(final int channel, final com.raritan.idl.pdumodel.Bcm.ChannelConfig config) throws Exception {
    JSONObject params = new JSONObject();
    params.put("channel", channel);
    params.put("config", com.raritan.json_rpc.pdumodel.Bcm.ChannelConfig_Codec.encode(config));
    final JSONObject result = rpcCall("setChannelConfig", params);
    SetChannelConfigResult ret = new SetChannelConfigResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setChannelConfig(final int channel, final com.raritan.idl.pdumodel.Bcm.ChannelConfig config, final AsyncRpcResponse<SetChannelConfigResult> rsp) {
    return setChannelConfig(channel, config, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setChannelConfig(final int channel, final com.raritan.idl.pdumodel.Bcm.ChannelConfig config, final AsyncRpcResponse<SetChannelConfigResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("channel", channel);
      params.put("config", com.raritan.json_rpc.pdumodel.Bcm.ChannelConfig_Codec.encode(config));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setChannelConfig", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetChannelConfigResult ret = new SetChannelConfigResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
