// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from CoreCtrl.idl.

package com.raritan.json_rpc.tfw;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class CoreCtrl_Proxy extends ObjectProxy implements com.raritan.idl.tfw.CoreCtrl {

  public CoreCtrl_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public CoreCtrl_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.tfw.CoreCtrl.typeInfo);
  }

  public static CoreCtrl_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new CoreCtrl_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetScannerResult getScanner(final String name) throws Exception {
    JSONObject params = new JSONObject();
    params.put("name", name);
    final JSONObject result = rpcCall("getScanner", params);
    GetScannerResult ret = new GetScannerResult();
    ret._ret_ = com.raritan.json_rpc.tfw.ScannerCtrl_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
    return ret;
  }

  @Override
  public AsyncRequest getScanner(final String name, final AsyncRpcResponse<GetScannerResult> rsp) {
    return getScanner(name, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getScanner(final String name, final AsyncRpcResponse<GetScannerResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("name", name);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getScanner", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetScannerResult ret = new GetScannerResult();
          ret._ret_ = com.raritan.json_rpc.tfw.ScannerCtrl_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void startAllScanners() throws Exception {
    JSONObject params = null;
    rpcCall("startAllScanners", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest startAllScanners(final AsyncRpcResponse<Void> rsp) {
    return startAllScanners(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest startAllScanners(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("startAllScanners", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void stopAllScanners() throws Exception {
    JSONObject params = null;
    rpcCall("stopAllScanners", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest stopAllScanners(final AsyncRpcResponse<Void> rsp) {
    return stopAllScanners(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest stopAllScanners(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("stopAllScanners", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void startAllBackWorkers() throws Exception {
    JSONObject params = null;
    rpcCall("startAllBackWorkers", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest startAllBackWorkers(final AsyncRpcResponse<Void> rsp) {
    return startAllBackWorkers(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest startAllBackWorkers(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("startAllBackWorkers", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void stopAllBackWorkers() throws Exception {
    JSONObject params = null;
    rpcCall("stopAllBackWorkers", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest stopAllBackWorkers(final AsyncRpcResponse<Void> rsp) {
    return stopAllBackWorkers(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest stopAllBackWorkers(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("stopAllBackWorkers", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
